"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emitOne = exports.emitMany = void 0;
const ArrayUtils = require("../utils/array_utils");
const Keywords = require("../tokens/keywords");
const Delimiters = require("../tokens/delimiters");
const NamespaceTokens = require("../tokens/namespace_tokens");
function emitMany(writer, imports) {
    if (ArrayUtils.isFalsy(imports))
        return;
    imports.forEach(x => emitOne(writer, x));
    writer.writeLine();
}
exports.emitMany = emitMany;
function emitOne(writer, _import) {
    const { path } = _import;
    writer.writeLine(Keywords.using, Delimiters.space, ...NamespaceTokens.emit(path), Delimiters.semicolon);
}
exports.emitOne = emitOne;
