"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = exports.Tokens = exports.Emitters = exports.Utils = void 0;
/// <reference path="../types/index.d.ts" />
exports.Utils = require("./utils/indented_string_writer");
exports.Emitters = require("./emitters");
exports.Tokens = require("./tokens");
const CodeUnitEmitter = require("./emitters/code_unit_emitter");
const indented_string_writer_1 = require("./utils/indented_string_writer");
/**
 * Emits a C# source text for a given language code unit object.
 * @param codeUnit The given C# code unit object to generate a source text.
 * @returns A C# source text for the given language code unit object.
 */
function emit(codeUnit) {
    const writer = new indented_string_writer_1.IndentedStringWriter(4);
    CodeUnitEmitter.emit(writer, codeUnit);
    return writer.toString();
}
exports.emit = emit;
