"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emit = void 0;
const Delimiters = require("./delimiters");
const TypeReferenceTokens = require("./type_reference_tokens");
const RoundBrackets = require("./round_brackets");
function emit(parameters) {
    const parameterTokens = parameters == null || parameters.length === 0 ? [] : precursors(parameters);
    return [RoundBrackets.open, ...parameterTokens, RoundBrackets.close];
}
exports.emit = emit;
function precursors(parameters) {
    return parameters
        .map(p => precursor(p))
        .flatMap((g, i, arr) => i === arr.length - 1 ? g : [...g, Delimiters.comma, Delimiters.space]);
}
function precursor(parameter) {
    const { type, name } = parameter;
    return [...TypeReferenceTokens.emit(type), Delimiters.space, name];
}
